package com.acme;

import com.sun.grizzly.tcp.Adapter;
import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.util.buf.ByteChunk;
import java.io.OutputStream;


public class MySimpleAdapter implements Adapter
{
    private static final int BUFFER_SIZE = 64 * 1024;

    private ByteChunk       bc;
    private OutputStream    os;
    private boolean         rejected;
    

    public MySimpleAdapter( boolean rejected )
    {
        this.bc = new ByteChunk( BUFFER_SIZE );
        this.os = new NullOutputStream();
        this.rejected = rejected;
    }
    
    @Override
    public void service( Request req, Response res ) throws Exception
    {
        int read;

        if( rejected )
        {
            res.setStatus( 509 );
            res.setMessage( "[Simple] Sorry but I don't want to process it ! It's my choice !" );
        }
        else
        {
            // Write somewhere the content of the request
            while( (read=req.doRead(bc))!=-1 )
            {
                os.write( bc.getBuffer(), bc.getStart(), read );
            }

            // Simulate some more time consuming operation
            Thread.sleep( 1500 );

            // Respond
            res.setStatus( 200 );
            res.setMessage( "[Simple] Ok, understand" );
        }
    }

    @Override
    public void afterService( Request rqst, Response rspns ) throws Exception
    {
        // Nothing to do !
    }

}
